function weatherBalloon( cityID ) {
	var key = '48954b66c9d54116dd164d4e1bcd1210';
	fetch('https://api.openweathermap.org/data/2.5/weather?id=' + cityID+ '&appid=' + key + '&units=Imperial')  
	.then(function(resp) { return resp.json() }) // Convert data to json
	.then(function(data) {
		drawCurrentWX(data);					
	})
	.catch(function() {
	// catch any errors
	});
}

function futureCast( cityID ) {
	var key = '48954b66c9d54116dd164d4e1bcd1210';
	fetch('https://api.openweathermap.org/data/2.5/forecast?id=' + cityID+ '&appid=' + key + '&units=Imperial')  
	.then(function(resp) { return resp.json() }) // Convert data to json
	.then(function(data) {
		//days = new Array(data.list[0],data.list[7],data.list[15],data.list[23],data.list[31],data.list[39]);
		//drawFutureWX(days);
		drawFutureWX(data.list);
	})
	.catch(function() {
	// catch any errors
	});
}		

function updateWX() {
	document.getElementById('dopplerimg').src = "https://radar.weather.gov/ridge/standard/KENX_loop.gif?refreshed="+(Date.now()/1000);
	weatherBalloon( 5129540 );
	futureCast( 5129540 );
	setTimeout(function() {
		updateWX();
	}, 300000); // 5 min
}

function drawCurrentWX( d ) {
	let compassSector = ["N", "NNE", "NE", "ENE", "E", "ESE", "SE", "SSE", "S", "SSW", "SW", "WSW", "W", "WNW", "NW", "NNW", "N"];
	var windDirection = compassSector[(d.wind.deg / 22.5).toFixed(0)];
	
	const desc = d.weather[0].description.split(" ");
	for (let i = 0; i < desc.length; i++) {
		desc[i] = desc[i][0].toUpperCase() + desc[i].substr(1);
	}
	
	document.getElementById('description').innerHTML = desc.join(" ").split(",").join(" ");
	document.getElementById('wind').innerHTML = "Wind "+ windDirection + " at " + Math.round(d.wind.speed,0) +"mph";
	if (d.wind.gust > 0 && Math.round(d.wind.gust,0) != Math.round(d.wind.speed,0)) document.getElementById('wind').innerHTML += " (gusting to "+Math.round(d.wind.gust,0)+"mph)";
	document.getElementById('temp').innerHTML = Math.round(d.main.temp,0) + '&deg;';
	if (Math.round(d.main.feels_like,0) != Math.round(d.main.temp,0)) document.getElementById('feels_like').innerHTML = "Feels like: "+Math.round(d.main.feels_like,0)+ '&deg;';
	document.getElementById('icon').innerHTML = "<img src=\"https://openweathermap.org/img/wn/"+d.weather[0].icon+"@4x.png\">";
}

function isToday(date) {
		var today = new Date();
		return date.getDate() == today.getDate() &&
		date.getMonth() == today.getMonth() &&
		date.getFullYear() == today.getFullYear()
}

let compassSector = ["N", "NNE", "NE", "ENE", "E", "ESE", "SE", "SSE", "S", "SSW", "SW", "WSW", "W", "WNW", "NW", "NNW", "N"];
var currentDay = null;
var count = 0;
var forecastHTML = "";
var limit = 3;

function drawTheFuture(d) {
	if (count > limit) return;
	var dob = new Date(d.dt * 1000);	
	var today = new Date();
	today.setHours(0,0,0,0);
	today = today.getTime();
	var dow = dob.toLocaleDateString("en-US", { weekday: 'long' });
	var id = "day0";
	var time = 0;
	var day = "";
	
	if (!isToday(dob)) {
		j = 0;
		fcday = dob.getTime();
		while (fcday - today >= 0) {
			today = today + 86400000;
			j++;
		}
		id = "day"+j;
	}
	var time = dob.getHours();
	var ampm = time >= 12 ? 'pm' : 'am';

	time = time % 12;
	time = time ? time : 12; // the hour '0' should be '12'
	time = time + ampm;
	if (currentDay != id && currentDay != null) {
		forecastHTML += "</tr></table></div>"
		document.getElementById(id).innerHTML = forecastHTML;
		forecastHTML = "";
	}
	if (currentDay != id) {
		count++;
		if (count > limit) return;
		if (id == "day0") day = "Today";
		else day = dow;
		
		forecastHTML += "<div class=\"forecast_day\"><strong>"+day+"</strong><br><table class=\"forecast_ext\"><tr>";
		currentDay = id;
	}
	var windDirection = compassSector[(d.wind.deg / 22.5).toFixed(0)];
	forecastHTML += "<td><center>"+time+"<br><img class=\"forecast_icon\" src=\"https://openweathermap.org/img/wn/"+d.weather[0].icon+"@2x.png\"><br>"+Math.round(d.main.temp,0) + '&deg;'+"<br>"+ Math.round(d.wind.speed,0) +"mph</center></td>";
}
function drawFutureWX( d ) {
	forecastHTML = "";
	currentDay = null;
	count = 0;
	for (i=0; i < d.length; i++) {
		if (i % 4 != 0) drawTheFuture(d[i]);
	}
}